# MVC3 "AJAX" File Upload

I put ajax in double quotes because this isn't ajax.  It just behaves like it.
This code is an ASP.NET MVC3 example of how to perform the iframe upload method.

When the user submits the form, an iframe is created and the target of the form is set to that
iframe.  The server receives the normal post request and sends back a bit of javascript based
on the success or failure of the upload.  This code in the Controller isn't implemented yet.
I did the dirty work, you can handle the rest.

When the response is received from inside the iframe, it calls the uploadComplete method from
the parent window which then DESTROYS the iframe and resets the target of the form.

## Controller:

```c#
[HttpPost]
public ActionResult Index(HttpPostedFileBase theFile)
{
    // store the file here

    var code = "Upload Successful!";

    var script =
    @"
        <script>
            parent.uploadComplete('{0}');
        </script>
    ";

    script = string.Format(script, code);

    var retval = new MvcHtmlString(script).ToString();
    return Content(retval);
}
```

## JavaScript:

```javascript
<script type="text/javascript">
    $(function() {
        $("form").bind("submit", function() {
            $(this).append('<iframe id="mediapicker-frame" name="mediapicker-frame" height="0" width="0" frameborder="0"></iframe>');
            $(this).attr("target", "mediapicker-frame");
            return true;
        });
    });

    function uploadComplete(code) {
        $('form iframe').remove();
        $('form').attr('target', '');
        $('#theFile').val('');
        alert(code);
    }
</script>
```